//半透进度面板  圆圈

cc.Class({
    extends: cc.Component,

    properties: {
        progressLabel : cc.Label,
        rootNode : cc.Node,
        animation : cc.Animation,
    },

    onLoad () {
        this.rootNode.active = false;
        G.eventCenter.on(g_eventTypes.loadEvent.showLittlePanel, this.show, this);
    },

    show () {
        if (this.rootNode.active) return cc.warn("loadingbox reshowed")

        this.rootNode.active = true;
        this.progressLabel.string = "0%";
        G.eventCenter.on(g_eventTypes.loadEvent.loadProgress, this.onProgressUpdate, this);
        G.eventCenter.on(g_eventTypes.loadEvent.loadComplete, this.hide, this);
    },

    hide () {
        this.rootNode.active = false;
        G.eventCenter.off(g_eventTypes.loadEvent.loadProgress, this.onProgressUpdate, this);
        G.eventCenter.off(g_eventTypes.loadEvent.loadComplete, this.hide, this);
    },

    onProgressUpdate (progress) {
        this.progressLabel.string = Math.floor(100 * progress) + "%";
    }
})