// 提示面板 会自动消失

cc.Class({
    extends: cc.Component,

    properties: {
        tipsLabel : cc.Label,
        bgNode : cc.Node,
        animation : cc.Animation,
    },

    onLoad () {
        this.bgNode.active = false
        if (this.animation) this.animation.on('finished', this.hide, this);
    },

    start () {
        G.eventCenter.on(g_eventTypes.UIEvent.showTips,this.show,this)
    },

    show(msg)
    {
        this.bgNode.active = true
        this.tipsLabel.string = msg
        if (this.animation) this.animation.play()
        
        this.scheduleOnce(()=>{
            this.bgNode.height = this.tipsLabel.node.height + 20
        }, 0.001)
    },
    hide()
    {
        this.bgNode.active = false
    }
});
