// 数据表管理

var TableProvider = function TableProvider() {
    this.tablesMap = {};
}
  
  TableProvider.prototype = {
    constructor: TableProvider,

    loadAllTables(completeCB,target)
    {
        let self = this
        // load all JSONs in "resources/tables/"
		cc.loader.loadResDir(g_resource.tablePath, function (err, objects, urls) {
            if (err) {
                console.error("load config error",err);
                if(completeCB)completeCB.call(target, err)
                return;
            }
            
            for (let i = 0; i < objects.length; ++i) {
                var data = objects[i].json;
                var url = urls[i];
                self.tablesMap[url] = data
            }

            self.init()

            if(completeCB)completeCB.call(target)
		});
    },

    init () {

    },

    // 获取表
    getTable (url) {
        return this.tablesMap[url]
    },

    // 获取数据
    getData (url, id) {
      var tableDatas = this.tablesMap[url];
      if (tableDatas) return tableDatas[id];
      return null;
    }
  };

  module.exports = TableProvider;