// 
var RANDOMMAX = 2147483647;
var RANDOMA = 16807;
var RANDOMB = 0;

var MyRandom = {
    seed: 0,
    randomTimes: 0,

    random: function random() {
        this.randomTimes++;
        this.seed = (this.seed * RANDOMA + RANDOMB) % RANDOMMAX;
        return MyMath.divide(1e3 * this.seed, RANDOMMAX);
    },

    randomInt: function randomInt(min, max) {
        this.Random0_1();
        var randValue = MyMath.divide((max - min) * this.seed, RANDOMMAX);
        return randValue + min;
    },

    setSeed: function setSeed(seed) {
        this.randomTimes = 0;
        this.seed = seed % RANDOMMAX;
    }
};

window.MyRandom = MyRandom;

module.exports = MyRandom;